(function () {

var csv = app.args && app.args.csv;
if (csv) {
	proceed({
		csvfile: csv
	});
	quit();
}

function proceed (params) {
	var timesets = {};
	params.csvfile.forEach({
		format: "csv",
		header: true,
		callback: function (line, header) {
			var obj = {};
			for (var i = 0; i < header.length; i++) {
				if (i >= line.length)
					continue;
				obj[header[i].toLowerCase()] = line[i];
			}

			var name = obj.name,
				timeset, period = {};
			if (name) {
				name = name.toUpperCase();
				timeset = timesets[name];
				if (!timeset) {
					timeset = {
						name: obj.name,
						periods: []
					};
					timesets[name] = timeset;
				}

				period.exclude = !!parseInt(obj.excluded);
				period.reserved = !!parseInt(obj.reserved);
				if (obj.days)
					period.recurring = obj.days.split(" ");
				period.start = obj.start;
				period.stop = obj.stop;
				period.duration = obj.duration;
				if (obj.group)
					period.group = obj.group;
				if (obj.department)
					period.department = obj.department;
				if (obj.owner)
					period.owner = obj.owner;
				if (obj.daterange)
					period.daterange = obj.daterange;

				timeset.periods.push(period);
			}
		}
	});

	for (var key in timesets) {
		var timeset = timesets[key],
			ts = new KSObject("timeset");
		ts.id = timeset.name;
		ts.periods = timeset.periods;
		ts.commit();
	}
}

return({
	version: 1,
	setup: {
		title: "Import Time Sets",
		id: "com.sassafras.timeset-import",
		fields: [
			{
				id: "csvfile",
				label: "Import CSV:",
				type: "file",
				required: true
			}
		]
	},
	proceed: proceed
});

})();
